package FromDualMySQLaria;

#
# Copyright (C) 2010 FromDual
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

use strict;
use warnings;
use FromDualMySQLagent ':stooges';

sub processAriaInformation
{
  my $parameter_ref = shift;

  my %hGlobalVariables;
  my %hGlobalStatus;

  my @aGlobalVariablesToSend = (
  'maria_pagecache_buffer_size', 'maria_block_size', 'maria_pagecache_blocks'
, 'aria_pagecache_buffer_size', 'aria_block_size', 'aria_pagecache_blocks'
  );

  my @aGlobalStatusToSend = (
  'Maria_pagecache_blocks_not_flushed', 'Maria_pagecache_blocks_unused', 'Maria_pagecache_blocks_used'
, 'Maria_pagecache_reads', 'Maria_pagecache_read_requests', 'Maria_pagecache_writes', 'Maria_pagecache_write_requests'
, 'Maria_transaction_log_syncs'
, 'Aria_pagecache_blocks_not_flushed', 'Aria_pagecache_blocks_unused', 'Aria_pagecache_blocks_used'
, 'Aria_pagecache_reads', 'Aria_pagecache_read_requests', 'Aria_pagecache_writes', 'Aria_pagecache_write_requests'
, 'Aria_transaction_log_syncs'
  );

  &FromDualMySQLagent::initValues(\%hGlobalVariables, \@aGlobalVariablesToSend);
  &FromDualMySQLagent::initValues(\%hGlobalStatus, \@aGlobalStatusToSend);

  my $dbh = &FromDualMySQLagent::getDatabaseConnection(\%$parameter_ref);

  if ( ! defined($dbh) ) {
    return -1;
  }

  &FromDualMySQLagent::getGlobalVariables(\%$parameter_ref, $dbh, \%hGlobalVariables);
  &FromDualMySQLagent::getGlobalStatus(\%$parameter_ref, $dbh, \%hGlobalStatus);

  &FromDualMySQLagent::releaseDatabaseConnection(\%$parameter_ref, $dbh);

  # Do some post calculations

  $hGlobalVariables{'maria_pagecache_blocks'} = $hGlobalVariables{'maria_block_size'} == 0 ? 0 : int($hGlobalVariables{'maria_pagecache_buffer_size'} / $hGlobalVariables{'maria_block_size'});
  $hGlobalVariables{'aria_pagecache_blocks'} = $hGlobalVariables{'aria_block_size'} == 0 ? 0 : int($hGlobalVariables{'aria_pagecache_buffer_size'} / $hGlobalVariables{'aria_block_size'});

  &FromDualMySQLagent::sendData(\%$parameter_ref, \%hGlobalVariables, \@aGlobalVariablesToSend, $$parameter_ref{'Domain'});
  &FromDualMySQLagent::sendData(\%$parameter_ref, \%hGlobalStatus, \@aGlobalStatusToSend, $$parameter_ref{'Domain'});
}

1;
__END__
